// Aufhängehaken für Sternleitung
// v0.1

// Renderauflösung Rundungen
// 12 = schnell, 72 = schön
$fn = 72;

haken();

module haken(){
    // Grunddaten
    HX = 15;    // Breite
    HY = 3*HX;  // Länge
    HZ = 3;     // Dicke
    WD = 2.5;   // Minimale Wanddicke
    
    k = 0.01;       // Korrekturfaktor gegen Oberflächenartefakte
    LD = HX-2*WD;   // Lochdurchmesser
    echo("Lochdurchmesser: ",LD);
    
    R1D = HX;       // Durchmesser Abrundung 1
    R1H = HZ;       // Höhe Abrundung 1
    R1XO = R1D/2;   // X-Offset Abrundung 1
    R1YO = R1D/2;   // Y-Offset Abrundung 1
    R1ZO = 0;       // Z-Offset Abrundung 1
    R2D = HX;       // Durchmesser Abrundung 1
    R2H = HZ;       // Höhe Abrundung 1
    R2XO = R1D/2;   // X-Offset Abrundung 1
    R2YO = HY-R2D/2;// Y-Offset Abrundung 1
    R2ZO = 0;       // Z-Offset Abrundung 1
    KX = HX;        // X-Größe Korpus
    KY = HY-HX;     // Y-Größe Korpus
    KZ = HZ;        // Z-Größe Korpus
    KXO = 0;        // X-Offset Korpus
    KYO = R1D/2;    // Y-Offset Korpus
    KZO = 0;        // Z-Offset Korpus
    
    // Loch unten
    L1D = LD;       // Durchmesser Loch 1
    L1H = HZ+2*k;   // Höhe Loch 1
    L1XO = HX/2;    // X-Offset Loch 1
    L1YO = L1D/2+WD;// Y-Offset Loch 1
    L1ZO = -k;      // Z-Offset Loch 1

    // Loch mitte
    L2D = LD;       // Durchmesser Loch 2
    L2H = HZ+2*k;   // Höhe Loch 2
    L2XO = HX/2;    // X-Offset Loch 2
    L2YO = HY/2;    // Y-Offset Loch 2
    L2ZO = -k;      // Z-Offset Loch 2

    // Loch oben
    L3D = LD;       // Durchmesser Loch 3
    L3H = HZ+2*k;   // Höhe Loch 3
    L3XO = HX/2;    // X-Offset Loch 3
    L3YO = HY-L3D/2-WD;// Y-Offset Loch 3
    L3ZO = -k;      // Z-Offset Loch 3
    
    // Hakenabschnitt unten
    H1X = HX/2+k;   // X-Breite
    H1Y = HX/4;     // Y-Breite
    H1Z = HZ+2*k;   // Z-Höhe
    H1XO = -k;      // X-Offset
    H1YO = R1D/2-H1Y/2;// Y-Offset
    H1ZO = -k;      // Z-Offset
    
    // Hakenabschnitt mitte
    H2X = HX/2+k;   // X-Breite
    H2Y = HX/4;     // Y-Breite
    H2Z = HZ+2*k;   // Z-Höhe
    H2XO = HX/2;    // X-Offset
    H2YO = HY/2-H2Y/2;// Y-Offset
    H2ZO = -k;      // Z-Offset


    difference(){
        // Grundform
        union(){
            translate([KXO,KYO,KZO]) cube([KX,KY,KZ]);
            translate([R1XO,R1YO,R1ZO]) cylinder(h=R1H, d=R1D);
            translate([R2XO,R2YO,R2ZO]) cylinder(h=R2H, d=R2D);
        }
        
        // Löcher
        translate([L1XO,L1YO,L1ZO]) cylinder(h=L1H, d=L1D);
        translate([L2XO,L2YO,L2ZO]) cylinder(h=L2H, d=L2D);
        translate([L3XO,L3YO,L3ZO]) cylinder(h=L3H, d=L3D);
        
        // Ausschnitte zum Haken
        translate([H1XO,H1YO,H1ZO]) cube([H1X,H1Y,H1Z]);
        translate([H2XO,H2YO,H2ZO]) cube([H2X,H2Y,H2Z]);
    }
}